commit 91586f969ddddc4ff4339167c05141141a4b6272
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Dec 21 15:54:59 2025 +0000

    Cmdline option for list of dynamic-load modules

diff --git a/src/src/drtables.c b/src/src/drtables.c
index 833c352c0..1b9dc0c98 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -224,6 +224,7 @@ const pcre2_code * regex_islookupmod = regex_must_compile(
 if (!(dd = exim_opendir(CUS LOOKUP_MODULE_DIR)))
   g = string_cat(g, US"FAIL exim_opendir");
 else
+  {
   for (struct dirent * ent; ent = readdir(dd); )
     {
     void * dl;
@@ -246,6 +247,8 @@ else
       dlclose(dl);
       }
     }
+  closedir(dd);
+  }
 #endif	/*!LOOKUP_MODULE_DIR*/
 return g;
 }
@@ -574,5 +577,37 @@ onetime = TRUE;
 }
 
 
+void
+mod_names(FILE * stream)
+{
+#ifdef LOOKUP_MODULE_DIR
+DIR * dd;
+gstring * list = NULL;
+const pcre2_code * regex_ismodule = regex_must_compile(
+  US"^([a-z0-9]+)_(?:lookup|auth|router|transport|miscmod)\\."
+    DYNLIB_FN_EXT "$",
+  MCS_NOFLAGS, TRUE);
+
+if ((dd = exim_opendir(CUS LOOKUP_MODULE_DIR)))
+  {
+  for (struct dirent * ent; ent = readdir(dd); )
+    if (regex_match_and_setup(regex_ismodule, US ent->d_name, 0, 0))
+      list = string_append_listele(list, ' ', expand_nstring[1]);
+  closedir(dd);
+
+  if (list)
+    fprintf(stream, "Installed modules: %s\n", string_from_gstring(list));
+  else
+    fprintf(stream, "No modules are installed\n");
+  }
+else
+  fprintf(stream, "Modules directory not readable\n");
+
+#else
+fprintf(stream, "Loadable-module support is not available\n");
+#endif
+}
+
+
 #endif	/*!MACRO_PREDEF*/
 /* End of drtables.c */
diff --git a/src/src/exim.c b/src/src/exim.c
index d8851d782..055882ad0 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -85,7 +85,7 @@ function_store_nullfree(void * block, void * tag)
 *************************************************/
 
 enum commandline_info { CMDINFO_NONE=0,
-  CMDINFO_HELP, CMDINFO_SIEVE,
+  CMDINFO_HELP, CMDINFO_SIEVE, CMDINFO_MODULES,
 #ifdef SUPPORT_DSCP
   CMDINFO_DSCP
 #endif
@@ -1392,9 +1392,13 @@ switch(request)
 #ifdef SUPPORT_DSCP
 "  exim -bI:dscp    list of known dscp value keywords\n"
 #endif
+"  exim -bI:modules list of loadable modules\n"
 "  exim -bI:sieve   list of supported sieve extensions\n"
 );
     return;
+  case CMDINFO_MODULES:
+    mod_names(stream);
+    return;
   case CMDINFO_SIEVE:
     {
     const misc_module_info * mi;
@@ -2436,6 +2440,8 @@ on the second character (the one after '-'), to save some effort. */
 	    if (Ustrlen(p))
 	      if (strcmpic(p, CUS"sieve") == 0)
 		{ info_flag = CMDINFO_SIEVE; info_stdout = TRUE; }
+	      else if (strcmpic(p, CUS"modules") == 0)
+		{ info_flag = CMDINFO_MODULES; info_stdout = TRUE; }
 #ifdef SUPPORT_DSCP
 	      else if (strcmpic(p, CUS"dscp") == 0)
 		{ info_flag = CMDINFO_DSCP; info_stdout = TRUE; }
diff --git a/src/src/functions.h b/src/src/functions.h
index 1923ca5b6..fe9d718ea 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -376,6 +376,7 @@ extern void    moan_write_references(FILE *, uschar *);
 #ifdef LOOKUP_MODULE_DIR
 //extern void    mod_load_check(const uschar *);
 #endif
+extern void    mod_names(FILE *);
 extern FILE   *modefopen(const uschar *, const char *, mode_t);
 
 extern int     open_cutthrough_connection(address_item *, BOOL);

